<?php
require __DIR__ . '/../XenForo/Autoloader.php';
XenForo_Autoloader::getInstance()->setupAutoloader(__DIR__ . '/../');
XenForo_Application::initialize(__DIR__ . '/../', __DIR__ . '/../../');

/**
 * Class MegaURL_API
 */
class MegaURL_API {

    public $request = [];

    private $model;

    protected static $default = [
        'tokencode' => '',
        'domains' => [],
        'patterns' => []
    ];

    /**
     * MegaURL_API constructor.
     */
    public function __construct()
    {
        ini_set('display_errors', true);
        error_reporting(E_ALL);

        $this->model = new XenForo_Model_Option();

        $this->request = array_merge([
            'action' => '',
            'tokencode' => '',
            'patterns' => [],
            'domains' => []
        ], $_REQUEST, (array)json_decode(file_get_contents('php://input'), true));

        if (method_exists($this, $this->request['action'])) {
            $output = $this->{$this->request['action']}();

            echo json_encode($output);
            exit;
        }
    }

    /**
     * @return bool true for success
     */
    public function update() {
        $value = array_filter($this->request, function($key) {
            return in_array($key, ['tokencode', 'patterns', 'domains']);
        }, ARRAY_FILTER_USE_KEY);

        $this->createOption();

        return $this->model->updateOption('megaurl', json_encode($value));
    }

    /**
     * @return array|false
     */
    public function get() {
        $get = $this->model->getOptionById('megaurl');
        return isset($get['option_value'])
            ? json_decode($get['option_value'])
            : static::$default;
    }

    protected function createOption() {
        $dw = XenForo_DataWriter::create('XenForo_DataWriter_Option');
        $hasOption = $this->model->getOptionById('megaurl');
        if ($hasOption) return;
        $dw->set('option_id', 'megaurl');
        $dw->set('option_value', '');
        $dw->set('default_value', json_encode(static::$default));
        $dw->set('edit_format', 'textbox');
        $dw->set('data_type', 'string');
        $dw->set('data_type', 'string');
        $dw->set('addon_id', 'MegaURL');
        $dw->save();
    }
}

new MegaURL_API();